'gbCodeFormatter Include v1.0 Gary L Beene and Larry Charlton 2 April 2014
'formatting of PowerBASIC source code

Global ManageBlankLines, StdComment, RemoveBlanks, procB, maxB, IndentSize, CommentPad As Long

Function TrimComments(temp$) As String
   Local i, qFlag As Long, c As String
   For i = 1 To Len(temp$)
      c = Mid$(temp$,i,1)
      If c = $Dq And qFlag = 1 Then
         qFlag = 0
      ElseIf c = $Dq Then
         qFlag = 1
      ElseIf c = "'" And qFlag = 0 Then
         Function = RTrim$(Left$(temp$,i-1))   'found single-quote character not embedded in double-quotes
         Exit Function
      End If
   Next i
   Function = temp$
End Function

Function StandardizeComments(temp$) As String
   Local i, qFlag As Long, c As String
   For i = 1 To Len(temp$)
      c = Mid$(temp$,i,1)
      If c = $Dq And qFlag = 1 Then
         qFlag = 0
      ElseIf c = $Dq Then
         qFlag = 1
      ElseIf c = "'" And qFlag = 0 Then
         Function = Left$(temp$,i-1) + "'" + Space$(CommentPad) + Trim$(Mid$(temp$,i+1))   ' found single-quote character not embedded in double-quotes
         Exit Function
      End If
   Next i
   Function = temp$
End Function

Sub SCIRemoveBlanks(hScintilla As Dword)
   Local temp$, i, iCount, SelLength As Long

   SciSelectWholeLines(hScintilla)                        'format only entire lines
   temp$ = Sci_GetSelText(hScintilla)                     'get selected text
   SelLength = Len(temp$)
   If Len(temp$) = 0 Then temp$ = Sci_GetText(hScintilla)
   If Len(temp$) = 0 Then Exit Sub

   'put into an array
   Dim tempArray(ParseCount(temp$, $CrLf)-1) As String
   Parse temp$, tempArray(), $CrLf
   Dim tempArrayB(UBound(tempArray)) As String

   'LTrim$ all
   iCount = -1
   For i = 0 To UBound(tempArray)
      If Len(Trim$(tempArray(i))) Then
         Incr iCount
         tempArrayB(iCount) = tempArray(i)
      End If
   Next i

   'set scintilla text
   If iCount = -1 Then Exit Sub             'no change to text
   If SelLength Then
      Sci_ReplaceSel hScintilla, Join$(tempArrayB(), $CrLf)
   Else
      Sci_SetText hScintilla, Join$(tempArrayB(), $CrLf)
   End If
End Sub

Sub SciLeftJustify(hScintilla As Dword)
   Local temp$, i As Long
   'get code
   temp$ = Sci_GetSelText(hScintilla)
   If Len(temp$) = 0 Then temp$ = Sci_GetText(hScintilla)
   If Len(temp$) = 0 Then Beep : Exit Sub

   'split code into array
   i = ParseCount(temp$, $CrLf)
   Dim tempArray(i -1) As String
   Parse temp$, tempArray(), $CrLf

   'LTrim$ all lines
   For i = 0 To UBound(tempArray)
      tempArray(i) = LTrim$(tempArray(i))
   Next i

   'put in report
   temp$ = Join$(tempArray(), $CrLf)
   Sci_SetText hScintilla, temp$
End Sub

Sub SciSelectWholeLines(hScintilla As Dword)
   Local i,j As Long
   i = SendMessage(hScintilla,%SCI_GetSelectionStart,0,0)      'start of selection
   j = SendMessage(hScintilla,%SCI_GetSelectionEnd,0,0)        'end of selection
   If i = j Then Exit Sub                                      'no selection
   i = SendMessage(hScintilla, %SCI_LineFromPosition,i,0)      'line containing start of selection
   j = SendMessage(hScintilla, %SCI_LineFromPosition,j,0)      'line containing end of selection
   i = SendMessage(hScintilla, %SCI_PositionFromLine, i,0)     '1st char in line containing start of selection
   j = SendMessage(hScintilla, %SCI_GetLineEndPosition, j,0)   'Last char in line containing end of selection
   SendMessage hScintilla, %SCI_SetSel, i,j
End Sub

   ' Troubleshooting indent
'   Macro PerformIndentAndGoto(preIndent,postIndent,beginProc) = iLevel+=preIndent: D(i) = Space$( iLevel*IndentSize) + D(i): iLevel+=postIndent: fFlag=IIf&(beginProc,1,0): GoTo Finish
   ' Safe indent
   Macro PerformIndentAndGoto(preIndent,postIndent,beginProc) = iLevel+=preIndent: D(i) = Space$( IIf(iLevel>-1,iLevel,0)*IndentSize) + D(i): iLevel+=postIndent: fFlag=IIf&(beginProc,1,0): GoTo Finish

Function SCIFormatCode(hScintilla As Dword) As String
   Local lctemp$,temp$,temp2$, iPos,bCount,i,j,k, SelLength As Long
   Local cFlag, fFlag,iLevel As Long
   Local inDecl, inStruct As Long
   Local ws As String
   Dim lcD() As String
   Dim tempD() As String
   Dim D() As String

   ws = $Spc + $Tab

   SciSelectWholeLines(hScintilla)                        'format only entire lines
   temp$ = Sci_GetSelText(hScintilla)                     'get selected text
   SelLength = Len(temp$)
   If Len(temp$) = 0 Then temp$ = Sci_GetText(hScintilla) 'if no selected text, format entire document
   If Len(temp$) = 0 Then Exit Function                   'if no text, do nothing and exit

   Replace $Tab With " " In temp$
   lctemp$ = LCase$(temp$)
   If InStr(lctemp$, "interface ") Or InStr(lctemp$, "property ") Or InStr(lctemp$, "method ") Then
      If InStr(lctemp$, "end class")=0 And InStr(lctemp$, "end method")=0 And InStr(lctemp$, "end property")=0 Then
         inDecl = 1
      End If
   End If

   i = ParseCount(temp$, $CrLf)
   ReDim D(i-1), lcD(i-1), tempD(4*i)
   Parse temp$,     D(), $CrLf
   Parse lctemp$, lcD(), $CrLf

   'test start of each line to know how much to indent
   iPos = -1
   For i = 0 To UBound(D)
      D(i) = Trim$(D(i), Any ws)
      If Len(D(i)) = 0 And ManageBlankLines Then Incr bCount : Iterate For
      If Len(D(i)) = 0 Then GoTo Finish
      temp$ = Trim$(TrimComments(lcD(i)), Any ws)
      Replace "(" With " ( " In temp$: ' While(-1)
      Replace "=" With " = " In temp$: ' While(-1)
      Replace ":" With " : " In temp$: ' handle any do: and friends
      temp$ = Shrink$( temp$, ws ) + " "

      If cFlag                                                                Then PerformIndentAndGoto(1,-1,0)    'previous line ended in _ so use this line as is, with indentation to iLevel, iLevel remains unchanged
      'If Right$(temp$,2)  = ": " And Verify(Trim$(temp$),Chr$(97 To 122, 48 To 58, 95)) = 0 Then
      If Right$(temp$,2)  = ": " And Verify(Trim$(Left$(temp$, Len(temp$)-3)),Chr$(97 To 122, 48 To 58, 95)) = 0 Then
         GoTo Finish    'labels  no indentation, lower case, numbers, underline
      End If

      'zero indentation constructs ==============================================================================================================================
      'single line, multi-statement constructs (No children)
      If Left$(temp$,6)  = "macro " And InStr(temp$,"=")                      Then PerformIndentAndGoto( 0,0,1)  ' Macro myMacro = x=2
      If Left$(temp$,5)  = "type " And Right$(temp$,9) = "end type "          Then PerformIndentAndGoto( 0,0,1)  ' Type x : ... : End Type
      If Left$(temp$,6)  = "union " And Right$(temp$,10) = "end union "       Then PerformIndentAndGoto( 0,0,1)  ' Union x : ... : End Union
      If Left$(temp$,4)  = "sub " And Right$(temp$,8) = "end sub "            Then PerformIndentAndGoto( 0,0,1)  ' Sub x : ... : End Sub
      If Left$(temp$,9)  = "function " And Right$(temp$,13) = "end function " Then PerformIndentAndGoto( 0,0,1)  ' Function x : ... : End Function
      If Left$(temp$,9)  = "callback " And Right$(temp$,13) = "end function " Then PerformIndentAndGoto( 0,0,1)  ' Callback Function x : ... : End Function
      If Left$(temp$,7)  = "thread " And Right$(temp$,13) = "end function "   Then PerformIndentAndGoto( 0,0,1)  ' Thread Function x : ... : End Function

      If Left$(temp$,9)  = "fastproc " And Right$(temp$,13) = "end fastproc " Then fFlag = 1 : PerformIndentAndGoto( 0,0,1)  ' FastProc x : ... : End FastProc
      If Left$(temp$,8)  = "asmdata " And Right$(temp$,12) = "end asmdata "   Then fFlag = 1 : PerformIndentAndGoto( 0,0,1)  ' ASMData x : ... : End ASMData

      'multi-line constructs (Children)
      If Left$(temp$,6)  = "macro " And inStruct=0                                         Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,9)  = "end macro"                                                     Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,5)  = "type " And inStruct = 0 And Left$(temp$,9) <> "type set "      Then inStruct=1: PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,8)  = "end type"                                                      Then inStruct=0: PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,6)  = "union " And inStruct = 0                                       Then inStruct=1: PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,9)  = "end union"                                                     Then inStruct=0: PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,4)  = "sub " And inStruct = 0                                         Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,7)  = "end sub"                                                       Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,9)  = "function " And inStruct=0 And Left$(temp$,10) <> "function ="  Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,9)  = "callback " And inStruct=0                                      Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,16) = "thread function "                                              Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,12) = "end function"                                                  Then PerformIndentAndGoto(-1,0,0)

      If Left$(temp$,5)  = "enum " And inStruct=0                                          Then inStruct=1: PerformIndentAndGoto( 0,1,0)
      If Left$(temp$,8)  = "end enum"                                                      Then inStruct=0: PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,8)  = "prefix ="                                                      Then PerformIndentAndGoto( 0,0,0)
      If Left$(temp$,7)  = "prefix " And inStruct=0                                        Then PerformIndentAndGoto( 0,1,0)
      If Left$(temp$,10) = "end prefix"                                                    Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,8)  = "asmdata " And inStruct=0                                       Then PerformIndentAndGoto( 0,1,0)
      If Left$(temp$,11) = "end asmdata"                                                   Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,9)  = "fastproc " And inStruct=0                                      Then PerformIndentAndGoto( 0,1,0)
      If Left$(temp$,12) = "end fastproc"                                                  Then PerformIndentAndGoto(-1,0,0)
      'n-level indentation constructs ===========================================================================================================================
      'single line, multi-statement constructs (No children)
      If Left$(temp$,3)  = "if "  And Right$(temp$, 3) = " _ " Then
         GoSub FindEndOfCommand
         If InStr(temp2$, "then ") And Len(Mid$(temp2$,InStr(-1,temp2$,"then ")+5)) > 1                                      Then PerformIndentAndGoto( 0,0,0)  ' If x then y=2
         If InStr(temp2$, "goto ")                                                                                           Then PerformIndentAndGoto( 0,0,0)  ' If x then y=2
         If InStr(temp2$, "else ") And Len(Mid$(temp2$,InStr(-1,temp2$,"else ")+5)) > 1                                      Then PerformIndentAndGoto( 0,0,0)  ' If x then y=2
      End If
      If Left$(temp$,4)  = "for " And Right$(temp$, 3) = " _ " Then
         GoSub FindEndOfCommand
         If InStr(-1,temp2$,"next ")                                                                                         Then PerformIndentAndGoto( 0,0,0)  ' For x=2 To 5 : next [i]
      End If
      If Left$(temp$,3)  = "do " And Right$(temp$, 3) = " _ " Then
         GoSub FindEndOfCommand
         If Right$(temp2$,5) = "loop "                                                                                       Then PerformIndentAndGoto( 0,0,0)  ' Do Until/While : ... : Loop
         If InStr(-1,temp2$,"loop while ") And Len(Mid$(temp2$,InStr(-1,temp2$,"loop while ")+11)) > 1                       Then PerformIndentAndGoto( 0,0,0)  ' Do .. : .. : Loop While x=2
         If InStr(-1,temp2$,"loop until ") And Len(Mid$(temp2$,InStr(-1,temp2$,"loop until ")+11)) > 1                       Then PerformIndentAndGoto( 0,0,0)  ' Do .. : .. : Loop Until x=2
      End If

      If Left$(temp$,3)  = "if "  And InStr(-1,temp$,"then ") And Len(Mid$(temp$,InStr(-1,temp$,"then ")+5)) > 1             Then PerformIndentAndGoto( 0,0,0)  ' If x then y=2
      If Left$(temp$,3)  = "if "  And InStr(-1,temp$,"goto ")                                                                Then PerformIndentAndGoto( 0,0,0)  ' If x then y=2
      If Left$(temp$,3)  = "if "  And InStr(-1,temp$,"else ") And Len(Mid$(temp$,InStr(-1,temp$,"else ")+5)) > 1             Then PerformIndentAndGoto( 0,0,0)  ' If x then y=2 else z=4
      If Left$(temp$,4)  = "for " And InStr(-1,temp$,"next ")                                                                Then PerformIndentAndGoto( 0,0,0)  ' For x=2 To 5 : next [i]
      If Left$(temp$,3)  = "do " And Right$(temp$,5) = "loop "                                                               Then PerformIndentAndGoto( 0,0,0)  ' Do Until/While : ... : Loop
      If Left$(temp$,3)  = "do " And InStr(-1,temp$,"loop while ") And Len(Mid$(temp$,InStr(-1,temp$,"loop while ")+11)) > 1 Then PerformIndentAndGoto( 0,0,0)  ' Do .. : .. : Loop While x=2
      If Left$(temp$,3)  = "do " And InStr(-1,temp$,"loop until ") And Len(Mid$(temp$,InStr(-1,temp$,"loop until ")+11)) > 1 Then PerformIndentAndGoto( 0,0,0)  ' Do .. : .. : Loop Until x=2
      If Left$(temp$,6)  = "while " And Right$(temp$,5) = "wend "                                                            Then PerformIndentAndGoto( 0,0,0)  ' While x=2 : y=3 : Wend
      If Left$(temp$,6)  = "while " And Right$(temp$,5) = "loop "                                                            Then PerformIndentAndGoto( 0,0,0)  ' While x=2 : y=3 : Loop
      If Left$(temp$,4)  = "try " And Right$(temp$,8) = "end try "                                                           Then PerformIndentAndGoto( 0,0,0)  ' Try : ... : ... : End Try

      'multi-line constructs (Children)
      If Left$(temp$,3)  = "if " And inStruct=0          Then PerformIndentAndGoto( 0,1,0)
      If Left$(temp$,7)  = "elseif " And inStruct=0      Then PerformIndentAndGoto(-1,1,0)
      If Left$(temp$,5)  = "else " And inStruct=0        Then PerformIndentAndGoto(-1,1,0)
      If Left$(temp$,6)  = "end if"                      Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,4)  = "#if "                        Then PerformIndentAndGoto( 0,1,0)
      If Left$(temp$,8)  = "#elseif "                    Then PerformIndentAndGoto(-1,1,0)
      If Left$(temp$,6)  = "#endif"                      Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,4)  = "for " And inStruct=0         Then PerformIndentAndGoto( 0,1,0)    ' For i = 1 to 10    (space after For)
      If Left$(temp$,5)  = "next " And inStruct = 0      Then PerformIndentAndGoto(-1,0,0)    ' Next i
      If Left$(temp$,3)  = "do " And inStruct=0          Then PerformIndentAndGoto( 0,1,0)
      If Left$(temp$,5)  = "loop " And inStruct = 0      Then PerformIndentAndGoto(-1,0,0)
      If Right$(temp$,5) = " loop" And Right$(temp$,10) <> "exit loop " And Right$(temp$,13)<>"iterate loop "  Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,6)  = "while " And inStruct = 0     Then PerformIndentAndGoto( 0,1,0)
      If Left$(temp$,5)  = "wend " And inStruct = 0      Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,9)  = "end while"                   Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,7)  = "select " And inStruct = 0    Then PerformIndentAndGoto( 0,2,0)
      If Left$(temp$,5)  = "case " And inStruct=0        Then PerformIndentAndGoto(-1,1,0)
      If Left$(temp$,10) = "case else "                  Then PerformIndentAndGoto(-1,1,0)
      If Left$(temp$,10) = "end select"                  Then PerformIndentAndGoto(-2,0,0)
      If Left$(temp$,4) = "try " And inStruct = 0        Then PerformIndentAndGoto( 0,1,0)
      If Left$(temp$,6) = "catch " And inStruct=0        Then PerformIndentAndGoto(-1,1,0)
      If Left$(temp$,8) = "finally " And Right$(temp$,8) = "end try "   Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,8) = "finally " And inStruct=0      Then PerformIndentAndGoto(-1,1,0)
      If Left$(temp$,8) = "end try "                     Then PerformIndentAndGoto(-1,0,0)    ' End Try :  (statement following on same line)
      'objects ==============================================================================================================================
      If Left$(temp$,13) = "class method "               Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,16) = "override method "            Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,6)  = "class " And inStruct=0       Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,9)  = "end class"                   Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,10) = "interface " And Right$(temp$,14) = "end interface "                  Then PerformIndentAndGoto( 0,0,1)  ' Interface : ... : End Interface
      If Left$(temp$,7)  = "method "    And Right$(temp$,11) = "end method "                     Then PerformIndentAndGoto( 0,0,1)  ' Method    : ... : End Method
      If Left$(temp$,10) = "interface " And inStruct = 0                                         Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,13) = "end interface"                                                       Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,10) = "property ="                                                          Then PerformIndentAndGoto( 0,0,0)
      If Left$(temp$,18) = "property objresult"                                                  Then PerformIndentAndGoto( 0,0,1)
      If Left$(temp$,9)  = "property " And Right$(temp$,13) =  "end property "                   Then PerformIndentAndGoto( 0,0,1)  ' Property  : ... : End Property
      If Left$(temp$,18) = "override property "                                                  Then PerformIndentAndGoto( 0,1,1)  ' Property  : ... : End Property
      If Left$(temp$,9)  = "property " And inStruct = 0 And inDecl = 1                           Then PerformIndentAndGoto( 0,0,1)  ' Property in declaration
      If Left$(temp$,9)  = "property " And inStruct = 0 And Right$(temp$,13) <> "end property "  Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,12) = "end property"                                                        Then PerformIndentAndGoto(-1,0,0)
      If Left$(temp$,8)  = "method ="                                Then PerformIndentAndGoto( 0,0,0)
      If Left$(temp,16)  = "method objresult"                        Then PerformIndentAndGoto( 0,0,1)
      If Left$(temp$,14) = "thread method "                          Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,7)  = "method " And inStruct = 0 And inDecl=1   Then PerformIndentAndGoto( 0,0,1): ' Method in declaration
      If Left$(temp$,7)  = "method " And inStruct = 0                Then PerformIndentAndGoto( 0,1,1)
      If Left$(temp$,10) = "end method"                              Then PerformIndentAndGoto(-1,0,0)

      'all other lines =====================================================================================================================
      PerformIndentAndGoto(0,0,0)

      Finish:
      If Right$(temp$,3) = " _ " Then cFlag = 1 Else cFlag = 0
      If fFlag And ManageBlankLines Then
         For j = 1 To procB : Incr iPos : Next j
      Else
         For j = 1 To Min(bCount,maxB) : Incr iPos : Next j
      End If
      Incr iPos : tempD(iPos) = IIf$(StdComment, StandardizeComments(D(i)),D(i) ) : bCount = 0 : fFlag = 0
   Next i
   ReDim Preserve tempD(iPos)

   'set scintilla text
   If SelLength Then
      Sci_ReplaceSel hScintilla, Join$(tempD(), $CrLf)
   Else
      Sci_SetText hScintilla, LTrim$(Join$(tempD(), $CrLf),$CrLf)
   End If
   Exit Function
   FindEndOfCommand:
   For k=i+1  To UBound(D)
      temp2$ = Trim$(TrimComments(lcD(k)), Any ws)
      Replace "(" With " ( " In temp2$: ' While(-1)
      Replace "=" With " = " In temp2$: ' While(-1)
      Replace ":" With " : " In temp2$: ' handle any do: and friends
      temp2$ = Shrink$( temp2$, ws ) + " "
      If Right$(temp2$, 3) <> " _ " Then Exit For
   Next
   Return
End Function
