-------------------------------------
' INTERFACE / END INTERFACE statements enclose the METHOD and PROPERTY definitions
' which constitute a class. There are two forms of the INTERFACE / END INTERFACE block.
' When it appears outside of a CLASS block, it is simply a declaration of the interface, much
' like DECLARE statements are used for functions:
-------------------------------------
Interface X
Method A
Method B
End Interface

Class Y
Interface X
Method A
' inside method
End Method
Method B
' inside method
End Method
End Interface
End Class

'Zero indentation constructs
Macro myMacro = x=2
Type x              : ... : End Type
Union x             : ... : End Union
Sub x               : ... : End Sub
Function x          : ... : End Function
CallBack Function x : ... : End Function
Thread Function x   : ... : End Function
FastProc x          : ... : End FastProc
AsmData x           : ... : End AsmData

'Multi-Line constructs (children) =======================================================================
Macro x
   'inside x
End Macro
Type x
   'inside x
   Type As Long
   Union As Long
   Sub As Long
   Function As Long
   Callback As Long
   Thread As Long
   Enum As Long
   AsmData As Long
   FastProc As Long
End Type
Union x
   'inside x
End Union
Sub x
   'inside s
End Sub
Function x() As Long
   'inside x
   Function = 0
End Function
CallBack Function x() As Long
   'inside x
   Function = 0
End Function
Thread Function x() As Long
   'inside x
   Function = 0
End Function
Enum x
   'inside x
End Enum

If Left$(temp$,8)  = "prefix ="                                                      Then PerformIndentAndGoto( 0,0,0)   ???????????

Prefix x
   'inside x
End Prefix
AsmData x
   'inside x
End AsmData
FastProc x() As Long
   'inside x
End FastProc

'n-Level indentation constructs =====================================================================

'single line, multi-statement constructs (No children)
If x Then y=2
For x=2 To 5 : Next i
Do Until/While : ... : Loop
Do .. : .. : Loop While x=2
Do .. : .. : Loop Until x=2
If x Then y=2
If x Then y=2
If x Then y=2 Else z=4
For x=2 To 5 : Next [i]
Do Until/While : ... : Loop
Do .. : .. : Loop While x=2
Do .. : .. : Loop Until x=2
While x=2 : y=3 : Wend
While x=2 : y=3 : Loop
Try : ... : ... : End Try

'multi-line constructs (Children) ==================================================================
If
   'inside x
ElseIf
   'inside x
Else
   'inside x
End If

#If
   'inside x
#ElseIf
   'inside x
#EndIf

For i = 1 To 10
   'inside x
Next i

Do
   'inside x
Loop

If Right$(temp$,5) = " loop" And Right$(temp$,10) <> "exit loop " And Right$(temp$,13)<>"iterate loop "  Then PerformIndentAndGoto(-1,0,0)  ???????????????

While
   'inside x
Wend

If Left$(temp$,9)  = "end while"                   Then PerformIndentAndGoto(-1,0,0)   ???????????????????????????????

Select
   Case
      'inside x
   Case Else                 ????????????????????????? 'why is this different than plain CASEe
      'inside x
End Select

Try
   'inside x
Catch
   'inside x
Finally
   'inside x
End Try

If Left$(temp$,8) = "finally " And Right$(temp$,8) = "end try "   Then PerformIndentAndGoto(-1,0,0)  ??????????????????????????????????


'objects ==============================================================================================================================
Class Method
   'inside x
End Method

Override Method
   'inside x
End Method

Class
   'inside x
End Clase

Interface : ... : End Interface
Method    : ... : End Method
Property  : ... : End Property
Property  : ... : End Property

If Left$(temp$,9)  = "property " And inStruct = 0 And inDecl = 1                           Then PerformIndentAndGoto( 0,0,1)  ' Property in declaration ????????????????????????????????

Interface
   'inside x
End Interface

If Left$(temp$,10) = "property ="                                                          Then PerformIndentAndGoto( 0,0,1)   ???????????????????????????
If Left$(temp$,18) = "property objresult"                                                  Then PerformIndentAndGoto( 0,0,1)   ??????????????????????????

Property
   'inside x
End Property

If Left$(temp$,8)  = "method ="                                Then PerformIndentAndGoto( 0,0,1)   ?????????????????????????????????
If Left$(temp,16)  = "method objresult"                        Then PerformIndentAndGoto( 0,0,1)   ?????????????????????????????????

Thread Method
   'inside x
End Method

Method
   'inside x
End Method

If Left$(temp$,7)  = "method " And inStruct = 0 And inDecl=1   Then PerformIndentAndGoto( 0,0,1): ' Method in declaration  ????????????????????????????
