Global hSearchD, hSciTarget, hSearchParent As Dword
Global CaseSensitive, SearchDialogShown, SearchDirectionD As Long
Global SearchTermD, ReplaceTermD As WStringZ * %Max_Path

Enum SearchEquates Singular
   IDS_FindThisLabel = 5000
   IDS_ReplaceWithLabel
   IDS_SearchTerm
   IDS_ReplaceTerm
   IDS_Replace
   IDS_ReplaceAll
   IDS_SearchNext
   IDS_SearchPrevious
   IDS_CaseSensitive
End Enum

Sub DisplaySearchDialog
   Local w,h As Long
   Dialog Get Client hSearchParent To h,w
   Dialog Font "Tahoma",10,0
   Dialog New Pixels, hSearchParent, "Find", 100, 100, 340, 100, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hSearchD
   Dialog Set Icon hSearchD, "xsearch"

   Control Add Label, hSearchD, %IDS_FindThisLabel, "Find This:", 5, 10, 80, 20
   Control Add Label, hSearchD, %IDS_FindThisLabel, "Replace With:", 5, 40, 80, 20

   If Len(Sci_GetSelText(hSciTarget)) Then SearchTermD = Sci_GetSelText(hSciTarget)
   Control Add TextBox, hSearchD, %IDS_SearchTerm, SearchTermD, 90, 10, 150, 20
   Control Add TextBox, hSearchD, %IDS_ReplaceTerm, ReplaceTermD, 90, 40, 150, 20

   Control Add Button, hSearchD, %IDS_SearchNext, "Find Next", 250, 10, 80, 25
   Control Add Button, hSearchD, %IDS_SearchPrevious, "Find Prev", 250, 40, 80, 25
   Control Add Button, hSearchD, %IDS_Replace, "Replace", 250, 70, 80, 25

   Control Add CheckBox, hSearchD, %IDS_CaseSensitive, "Case Sensitive", 10, 70, 100, 20
   Control Set Check hSearchD, %IDS_CaseSensitive, CaseSensitive

   Control Add Button, hSearchD, %IdOk, "Ok", 200, 230, 20, 20
   Control Add Button, hSearchD, %IdCancel, "Cancel", 230, 230, 20, 20
   Control Show State hSearchD, %IdOk, %SW_Hide
   Control Show State hSearchD, %IdCancel, %SW_Hide

   SearchDialogShown = 1
   Dialog Show Modeless hSearchD Call SearchProc()
   Do                                                                    'because we want to be able
      Dialog DoEvents                                                     'to edit main text while
   Loop Until SearchDialogShown = 0

End Sub

CallBack Function SearchProc() As Long
   Local SearchResult As Long, temp$
   Select Case Cb.Msg
      Case %WM_SYSCOMMAND
         If (Cb.WParam And &HFFF0) = %SC_Close Then          'trap Alt-F4 and X Button
            SearchDialogShown = 0
         End If

      Case %IdCancel
         Dialog End hSearchD
         SearchDialogShown = 0

      Case %WM_Destroy
         SearchDialogShown = 0
         Settings_INI "save"

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDS_SearchTerm
               Select Case Cb.CtlMsg
                  Case %EN_Change
                     Control Get Text hSearchD, %IDS_SearchTerm To SearchTermD
               End Select
            Case %IDS_CaseSensitive
               Control Get Check hSearchD, %IDS_CaseSensitive To CaseSensitive
            Case %IDS_Replace
               temp$ = Sci_GetSelText(hSciTarget)
               If Len(temp$) Then     'apply only to a selection
                  Control Get Text hSearchD, %IDS_ReplaceTerm To ReplaceTermD
                  If Len(ReplaceTermD) Then
                     Sci_ReplaceSel hSciTarget, ReplaceTermD
                     SciFindText
                  End If
               End If
            Case %IdCancel
               Dialog End hSearchD
               SciFindText
            Case %IdOk
               SciFindText
            Case %IDS_SearchNext                                                   'search forward
               SearchDirectionD = 1
               SciFindText
            Case %IDS_SearchPrevious                                                'search backward
               SearchDirectionD = 0
               SciFindText
         End Select
   End Select
End Function

Function SciFindText() As Long
   Local iResult,FindFlags As Long, FindStructure As Sci_TextToFind, sTerm$
   FindFlags = CaseSensitive * %SCFind_MatchCase

   FindStructure.Chrg.cpMin = SendMessage(hSciTarget,IIf(SearchDirectionD, %SCI_GetCurrentPos, %SCI_GetAnchor),0,0) 'if up-curpos, if down-anchor
   FindStructure.Chrg.cpMax = SearchDirectionD * SendMessage(hSciTarget,%SCI_GetLength,0,0) 'if up-length   if down-0
   sTerm$ = SearchTermD
   FindStructure.lpstrText = StrPtr(sTerm$)
   iResult = SendMessage (hSciTarget, %SCI_FindText, FindFlags, VarPtr(FindStructure))
   If iResult = -1 Then
      Function = 0   'no match
      If SearchDirectionD = 1 Then Beep 'MsgBox "Match not found between current position and end of document!", %MB_Ok Or %MB_TaskModal or %MB_IconExclamation, "Find Text"
      If SearchDirectionD = 0 Then Beep 'MsgBox "Match not found between current position and beginning of document!", %MB_Ok Or %MB_TaskModal or %MB_IconExclamation, "Find Text"
   Else
      Function = 1   'match found
      SendMessage hSciTarget, %SCI_SetSel, FindStructure.ChrgText.cpMin, FindStructure.ChrgText.cpMax
   End If
End Function
