'Compilable Example:
'Jose Roca includes are used (scictrl.inc)
#Compiler PBWin 10
#Compile Exe "gbcodeindent3.exe"
#Dim All

#Debug Error On
#Debug Display On

%Unicode=1
#Include "win32api.inc"
#Include "scictrl.inc"
#Include "files\gbcodeformatter.inc"
#Include "files\gbscintillasearch.inc"

#Resource Icon logo "icons\gbcodeindent3.ico"
#Resource Icon xopen "icons\folder.ico"
#Resource Icon xsave "icons\save.ico"
#Resource Icon xhelp "icons\help.ico"
#Resource Icon xundo "icons\undo.ico"
#Resource Icon xredo "icons\redo.ico"
#Resource Icon xsettings "icons\settings.ico"
#Resource Icon xcomment "icons\comment.ico"
#Resource Icon xuncomment "icons\uncomment.ico"
#Resource Icon xindent "icons\indent.ico"
#Resource Icon xoutdent "icons\outdent.ico"
#Resource Icon xunformat "icons\unformat.ico"
#Resource Icon xclear "icons\clear.ico"
#Resource Icon xcopyall "icons\copy.ico"
#Resource Icon xpaste "icons\paste.ico"
#Resource Icon xfont "icons\font.ico"
#Resource Icon xsearch "icons\search.ico"
#Resource Icon xpbwin "icons\pbwin.ico"
#Resource Icon xcompile "icons\compile.ico"

Type CustomColors
   c(15) As Long
End Type

Enum Equates Singular
   IDC_Sci = 1000
   IDC_Toolbar
   IDC_StatusBar

   IDT_Open
   IDT_SaveAs
   IDT_Format
   IDT_Plain
   IDT_Undo
   IDT_Redo
   IDT_Quote
   IDT_UnQuote
   IDT_Indent
   IDT_OutDent
   IDT_Font
   IDT_Clear
   IDT_CopyAll
   IDT_Paste
   IDT_OpenInIDE
   IDT_CompileAndRun
   IDT_Search
   IDT_Settings
   IDT_Help

   IDM_ToolbarText
   IDM_MiniBar
   IDM_Font
   IDM_StdComment
   IDM_RemoveBlanks
   IDM_ManageBlankLines
   IDM_Sep
   IDM_Reset
   IDM_Reload
   IDM_GoToLine

   IDM_Search

   IDM_SelectIDE
   IDM_SelectCompiler
   IDM_SelectPBInclude
   IDM_SelectJoseRocaInclude
   IDM_UseJose

   IDM_Indent0
   IDM_Indent1
   IDM_Indent2
   IDM_Indent3
   IDM_Indent4
   IDM_Indent5
   IDM_Indent6
   IDM_Indent7
   IDM_Indent8

   IDM_MaxB0
   IDM_MaxB1
   IDM_MaxB2
   IDM_MaxB3
   IDM_MaxB4
   IDM_MaxB5

   IDM_ProcB0
   IDM_ProcB1
   IDM_ProcB2
   IDM_ProcB3
   IDM_ProcB4
   IDM_ProcB5

   IDM_Pad0
   IDM_Pad1
   IDM_Pad2
   IDM_Pad3
   IDM_Pad4
   IDM_Pad5

   IDM_ColorKeyWord
   IDM_ColorComment
   IDM_ColorString
   IDM_ColorNumber
   IDM_ColorOperator

End Enum

$ver = "3.3"
$KeyWordFile = "files\keywords.txt"

$EXEFile                     = "tempfiles\gbcodeindent_temp.exe"      'created by compiler
$LogFile                     = "tempfiles\gbcodeindent_temp.log"      'created by compiler
$TempSourceCodeFile_IDE      = "tempfiles\gbcodeindent_temp.bas"      'sent to PowerBASIC IDE from Snippet Library
$TempSourceCodeFile_Compiler = "tempfiles\gbcodeindent_temp.bas"      'sent to compiler
$TempCompilerLogFile         = "tempfiles\gbcodeindent_temp.log"      'sent to PowerBASIC IDE from Snippet Library

Global hDlg, hSci, hLib, hToolbar, hSettings, ghHook As Dword
Global hIndent,hPad,hProcB,hMaxB,hPBWin,hOpen As Dword, LastGoTo As Long

Global FontSize, FontAttr, ToolbarText, MiniBar,TBH,SciMargin As Long
Global Keywords As String, FontName, FileExt,FileName As WStringZ * %Max_Path
Global CustomColorList As CustomColors
Global ColorKeyWord, ColorString, ColorComment,ColorNumber,ColorOperator As Long

Global UseJose As Long
Global PathIncludePB, PathIncludeJR, PathCompiler, PathIDE  As WStringZ * %Max_Path

Function PBMain() As Long
   Dialog Font "Tahoma", 10, 0
   Dialog New Pixels, 0, "gbCodeIndent  v" + $ver,300,300,370,350, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   DragAcceptFiles hDlg, %True
   Control Add Statusbar, hDlg, %IDC_Statusbar, "", 0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local i,j As Long, nmtb As TBNotify Ptr, rc As Rect, PTT As TooltipText Ptr, tempZ As WStringZ * %Max_Path
   Select Case Cb.Msg
      Case %WM_InitDialog
         CreateSubFolders
         BuildAcceleratorTable
         settings_INI "get"
         CreateScintilla
         CreateToolbar
         Dialog Set Text hDlg, "gbCodeIndent  v" + $Ver + "     " + FileName
         LoadKeyWords
         CreateContextMenus
         InitializeSci
         SetSciFont
         LoadFileName
         SetMenusAndToolbar
         PostMessage hSci, %SCI_SetSel, 0,0 'unselect initially
      Case %WM_DROPFILES
         DragQueryFile Cb.WParam, 0, tempZ, SizeOf(tempZ)
         If IsFile(tempZ) And InStr(FileExt,LCase$(Right$(tempZ,4))) Then
            FileName = tempZ
            LoadFileName
         End If
         DragFinish Cb.WParam
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_Open      : SelectAndOpenFile
            Case %IDT_SaveAs    : SaveAsFile
            Case %IDT_Format    : SciFormatCode(hSci)
            Case %IDT_Plain     : SciLeftJustify(hSci) : If RemoveBlanks Then SciRemoveBlanks(hSci)
            Case %IDT_Help      : i = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbcodeindent.htm", $Nul, $Nul, %SW_ShowNormal)
            Case %IDT_Font,%IDM_Font      : SelectMainFont
            Case %IDT_Undo      : Sci_Undo hSci
            Case %IDT_Redo      : Sci_Redo hSci
            Case %IDT_Indent    : Sci_TAB hSci
            Case %IDT_Outdent   : Sci_BackTAB hSci
            Case %IDT_Quote     : Sci_BlockComment hSci
            Case %IDT_UnQuote   : Sci_BlockUnComment hSci

            Case %IDT_Search, %IDM_Search
               hSearchParent = hDlg
               hSciTarget = hSci
               DisplaySearchDialog

            Case %IDM_GoToLine     : GoToLine

            Case %IDT_Clear
               Sci_ClearAll hSci

            Case %IDT_CopyAll
               Clipboard Reset : Clipboard Set Text Sci_GetText(hSci)

            Case %IDT_Paste
               Sci_Paste hSci

            Case %IDT_OpenInIDE     : OpenInIDE
            Case %IDT_CompileAndRun : CompileAndRun

            Case %IDT_Settings  : ShowReport

            Case %IDM_ToolbarText
               ToolbarText Xor= 1
               TBH = IIf(ToolbarText,55,40)
               CreateToolbar
               Control Set Loc hDlg, %IDC_Sci, 5,TBH
               ResizeWindow
               SetMenusAndToolbar

            Case %IDM_MiniBar
               MiniBar Xor=1
               CreateToolbar
               SetMenusAndToolbar

            Case %IDM_ManageBlankLines
               ManageBlankLines Xor= 1
               SetMenusAndToolbar

            Case %IDM_RemoveBlanks
               RemoveBlanks Xor= 1
               SetMenusAndToolbar

            Case %IDM_StdComment
               StdComment Xor= 1
               SetMenusAndToolbar

            Case %IDM_Reload
               LoadFileName

            Case %IDM_Reset
               ManageBlankLines = 1 : StdComment = 1 : RemoveBlanks = 1
               ProcB = 2 : MaxB = 1 : IndentSize = 3 : CommentPad = 1

            Case %IDM_Indent0 : IndentSize = 0 : SetMenusAndToolbar
            Case %IDM_Indent1 : IndentSize = 1 : SetMenusAndToolbar
            Case %IDM_Indent2 : IndentSize = 2 : SetMenusAndToolbar
            Case %IDM_Indent3 : IndentSize = 3 : SetMenusAndToolbar
            Case %IDM_Indent4 : IndentSize = 4 : SetMenusAndToolbar
            Case %IDM_Indent5 : IndentSize = 5 : SetMenusAndToolbar
            Case %IDM_Indent6 : IndentSize = 6 : SetMenusAndToolbar
            Case %IDM_Indent7 : IndentSize = 7 : SetMenusAndToolbar
            Case %IDM_Indent8 : IndentSize = 8 : SetMenusAndToolbar

            Case %IDM_MaxB0 : MaxB = 0 : SetMenusAndToolbar
            Case %IDM_MaxB1 : MaxB = 1 : SetMenusAndToolbar
            Case %IDM_MaxB2 : MaxB = 2 : SetMenusAndToolbar
            Case %IDM_MaxB3 : MaxB = 3 : SetMenusAndToolbar
            Case %IDM_MaxB4 : MaxB = 4 : SetMenusAndToolbar
            Case %IDM_MaxB5 : MaxB = 5 : SetMenusAndToolbar

            Case %IDM_ProcB0 : ProcB = 0 : SetMenusAndToolbar
            Case %IDM_ProcB1 : ProcB = 1 : SetMenusAndToolbar
            Case %IDM_ProcB2 : ProcB = 2 : SetMenusAndToolbar
            Case %IDM_ProcB3 : ProcB = 3 : SetMenusAndToolbar
            Case %IDM_ProcB4 : ProcB = 4 : SetMenusAndToolbar
            Case %IDM_ProcB5 : ProcB = 5 : SetMenusAndToolbar

            Case %IDM_Pad0 : CommentPad = 0 : SetMenusAndToolbar
            Case %IDM_Pad1 : CommentPad = 1 : SetMenusAndToolbar
            Case %IDM_Pad2 : CommentPad = 2 : SetMenusAndToolbar
            Case %IDM_Pad3 : CommentPad = 3 : SetMenusAndToolbar
            Case %IDM_Pad4 : CommentPad = 4 : SetMenusAndToolbar
            Case %IDM_Pad5 : CommentPad = 5 : SetMenusAndToolbar

            Case %IDM_ColorKeyword
               ColorKeyWord = SelectColor (ColorKeyWord)
               SendMessage hSci, %SCI_StyleSetFore, %SCE_B_KeyWord,  ColorKeyword
            Case %IDM_ColorComment
               ColorComment = SelectColor (ColorComment)
               SendMessage hSci, %SCI_StyleSetFore, %SCE_B_Comment,  ColorComment
            Case %IDM_ColorString
               ColorString = SelectColor (ColorString)
               SendMessage hSci, %SCI_StyleSetFore, %SCE_B_String,  ColorString
            Case %IDM_ColorNumber
               ColorNumber = SelectColor (ColorOperator)
               SendMessage hSci, %SCI_StyleSetFore, %SCE_B_Operator,  ColorOperator
            Case %IDM_ColorOperator
               ColorOperator = SelectColor (ColorNumber)
               SendMessage hSci, %SCI_StyleSetFore, %SCE_B_Number,  ColorNumber

            Case %IDM_SelectIDE              : SelectIDE
            Case %IDM_SelectCompiler         : SelectCompiler
            Case %IDM_SelectPBInclude        : SelectPBInclude
            Case %IDM_SelectJoseRocaInclude  : SelectJoseRocaInclude
            Case %IDM_UseJose                : UseJose = UseJose Xor 1 : SetMenusAndToolbar

         End Select
      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_Open To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_Open          : @PTT.@lpszText = "Open existing source code file"
                        Case %IDT_SaveAs        : @PTT.@lpszText = "Save source code to a new file"
                        Case %IDT_Clear         : @PTT.@lpszText = "Delete all text"
                        Case %IDT_CopyAll       : @PTT.@lpszText = "Copy all source code"
                        Case %IDT_Paste         : @PTT.@lpszText = "Paste clipboard content at cursor"
                        Case %IDT_Search        : @PTT.@lpszText = "Open Find & Replace Dialog"
                        Case %IDT_Plain         : @PTT.@lpszText = IIf$(RemoveBlanks,"Left justify all text and remove all blanks","Left justify all text")
                        Case %IDT_Format        : @PTT.@lpszText = "Format all source code"
                        Case %IDT_Undo          : @PTT.@lpszText = "Undo last editing action"
                        Case %IDT_Redo          : @PTT.@lpszText = "Restore last Undo action"
                        Case %IDT_Quote         : @PTT.@lpszText = "Add single quote to selected lines"
                        Case %IDT_UnQuote       : @PTT.@lpszText = "Remove single quote from selected lines"
                        Case %IDT_Indent        : @PTT.@lpszText = "Indent selected lines"
                        Case %IDT_Outdent       : @PTT.@lpszText = "Un-indent selected lines"
                        Case %IDT_Font          : @PTT.@lpszText = "Display Select Font dialog"
                        Case %IDT_Settings      : @PTT.@lpszText = "Displays Settings"
                        Case %IDT_Help          : @PTT.@lpszText = "Open Online Help Page"
                     End Select
               End Select
            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     Select Case @nmtb.iItem
                        Case %IDT_Open
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           TrackPopupMenu (hOpen, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_CompileAndRun
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           TrackPopupMenu (hPBWin, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Settings
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select
         End Select

      Case %WM_Size : ResizeWindow
      Case %WM_Destroy
         settings_INI "save"
         If hLib Then FreeLibrary hLib             ' Free the Scintilla library
   End Select
End Function

Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_Sci, w-10,h-TBH-25
End Sub

Sub CreateScintilla
   hLib = LoadLibrary(Exe.Path$ + "scilexer.dll")
   Control Add "Scintilla", hDlg, %IDC_Sci, "", 5,TBH,180,350, %WS_Child Or %WS_Visible, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_Sci To hSci     'get handle to Scintilla window
End Sub

Sub InitializeSci
   SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_KEYWORD,    ColorKeyWord
   SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_STRING,     ColorString
   SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_COMMENT,    ColorComment
   SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_OPERATOR,   ColorOperator
   SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_NUMBER,     ColorNumber
   SendMessage hSci, %SCI_SETKEYWORDS,     0,                 ByVal StrPtr(KeyWords) 'define PB keywords
   SendMessage hSci, %SCI_SetMarginWidthN, 0,                 SciMargin              'display line numbers
   SendMessage hSci, %SCI_SETLEXER, %SCLEX_PowerBASIC, 0    'built-in PB lexer
   SendMessage hSci, %SCI_Colourise, 0, -1                  'colourize from 0 to end-of-doc
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(4)
   ac(c).fvirt = %FVIRTKEY               : ac(c).key   = %VK_F1  : ac(c).cmd   = %IDT_Help    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL  : ac(c).key   = %VK_F   : ac(c).cmd  = %IDM_Search   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL  : ac(c).key   = %VK_G   : ac(c).cmd  = %IDM_GoToLine : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL  : ac(c).key   = %VK_L   : ac(c).cmd  = %IDM_ReLoad   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL  : ac(c).key   = %VK_R   : ac(c).cmd  = %IDM_Reset    : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateToolbar
    Control Kill hDlg, %IDC_Toolbar

    Local hImageList As Dword
    ImageList New Icon 24,24,24,20 To hImageList
    ImageList Add Icon hImageList, "xopen"     '1
    ImageList Add Icon hImageList, "xsave"     '2
    ImageList Add Icon hImageList, "logo"      '3
    ImageList Add Icon hImageList, "xhelp"     '4
    ImageList Add Icon hImageList, "xundo"     '5
    ImageList Add Icon hImageList, "xsettings" '6
    ImageList Add Icon hImageList, "xredo"     '7
    ImageList Add Icon hImageList, "xcomment"  '8
    ImageList Add Icon hImageList, "xuncomment"'9
    ImageList Add Icon hImageList, "xindent"   '10
    ImageList Add Icon hImageList, "xoutdent"  '11
    ImageList Add Icon hImageList, "xunformat" '12
    ImageList Add Icon hImageList, "xfont"     '13
    ImageList Add Icon hImageList, "xclear"    '14
    ImageList Add Icon hImageList, "xcopyall"  '15
    ImageList Add Icon hImageList, "xpaste"    '16
    ImageList Add Icon hImageList, "xsearch"   '17
    ImageList Add Icon hImageList, "xpbwin"    '18
    ImageList Add Icon hImageList, "xcompile"  '19

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0
    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_Open, %BTNS_Button Or %BTNS_DropDown, IIf$(ToolbarText,"Open","")
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_SaveAs, %BTNS_Button, IIf$(ToolbarText,"SaveAs","")
    If MiniBar = 0 Then
       Toolbar Add Separator hDlg, %IDC_Toolbar, 20
       Toolbar Add Button    hDlg, %IDC_Toolbar, 14,  %IDT_Clear, %BTNS_Button, IIf$(ToolbarText,"Clear","")
       Toolbar Add Button    hDlg, %IDC_Toolbar, 15,  %IDT_CopyAll, %BTNS_Button, IIf$(ToolbarText,"CopyAll","")
       Toolbar Add Button    hDlg, %IDC_Toolbar, 16,  %IDT_Paste, %BTNS_Button, IIf$(ToolbarText,"Paste","")
       Toolbar Add Separator hDlg, %IDC_Toolbar, 20
       Toolbar Add Button    hDlg, %IDC_Toolbar, 17,  %IDT_Search, %BTNS_Button, IIf$(ToolbarText,"Find","")
    End If
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 12,  %IDT_Plain, %BTNS_Button, IIf$(ToolbarText,"Plain","")
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Format, %BTNS_Button, IIf$(ToolbarText,"Format","")
    If MiniBar = 0 Then
       Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Undo, %BTNS_Button, IIf$(ToolbarText,"Undo","")
       Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_Redo, %BTNS_Button, IIf$(ToolbarText,"Redo","")
       Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    End If
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_Quote, %BTNS_Button, IIf$(ToolbarText,"Quote","")
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_UnQuote, %BTNS_Button, IIf$(ToolbarText,"UnQuote","")
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10,  %IDT_Indent, %BTNS_Button, IIf$(ToolbarText,"Indent","")
    Toolbar Add Button    hDlg, %IDC_Toolbar, 11,  %IDT_Outdent, %BTNS_Button, IIf$(ToolbarText,"Outdent","")
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 18, %IDT_OpenInIDE,  %BTNS_Button, IIf$(ToolbarText,"IDE","")
    Toolbar Add Button    hDlg, %IDC_Toolbar, 19, %IDT_CompileAndRun,  %BTNS_Button Or %BTNS_DropDown, IIf$(ToolbarText,"Run","")
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    If MiniBar = 0 Then
       Toolbar Add Button    hDlg, %IDC_Toolbar, 13,  %IDT_Font, %BTNS_Button, IIf$(ToolbarText,"Font","")
    End If
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, IIf$(ToolbarText,"Settings","")
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Help,  %BTNS_Button, IIf$(ToolbarText,"Help","")
End Sub

Sub CreateContextMenus
   Menu New PopUp To hIndent
   Menu Add String, hIndent, "0", %IDM_Indent0, %MF_Enabled
   Menu Add String, hIndent, "1", %IDM_Indent1, %MF_Enabled
   Menu Add String, hIndent, "2", %IDM_Indent2, %MF_Enabled
   Menu Add String, hIndent, "3", %IDM_Indent3, %MF_Enabled
   Menu Add String, hIndent, "4", %IDM_Indent4, %MF_Enabled
   Menu Add String, hIndent, "5", %IDM_Indent5, %MF_Enabled
   Menu Add String, hIndent, "6", %IDM_Indent6, %MF_Enabled
   Menu Add String, hIndent, "7", %IDM_Indent7, %MF_Enabled
   Menu Add String, hIndent, "8", %IDM_Indent8, %MF_Enabled

   Menu New PopUp To hMaxB
   Menu Add String, hMaxB, "0", %IDM_MaxB0, %MF_Enabled
   Menu Add String, hMaxB, "1", %IDM_MaxB1, %MF_Enabled
   Menu Add String, hMaxB, "2", %IDM_MaxB2, %MF_Enabled
   Menu Add String, hMaxB, "3", %IDM_MaxB3, %MF_Enabled
   Menu Add String, hMaxB, "4", %IDM_MaxB4, %MF_Enabled
   Menu Add String, hMaxB, "5", %IDM_MaxB5, %MF_Enabled

   Menu New PopUp To hProcB
   Menu Add String, hProcB, "0", %IDM_ProcB0, %MF_Enabled
   Menu Add String, hProcB, "1", %IDM_ProcB1, %MF_Enabled
   Menu Add String, hProcB, "2", %IDM_ProcB2, %MF_Enabled
   Menu Add String, hProcB, "3", %IDM_ProcB3, %MF_Enabled
   Menu Add String, hProcB, "4", %IDM_ProcB4, %MF_Enabled
   Menu Add String, hProcB, "5", %IDM_ProcB5, %MF_Enabled

   Menu New PopUp To hPad
   Menu Add String, hPad, "0", %IDM_Pad0, %MF_Enabled
   Menu Add String, hPad, "1", %IDM_Pad1, %MF_Enabled
   Menu Add String, hPad, "2", %IDM_Pad2, %MF_Enabled
   Menu Add String, hPad, "3", %IDM_Pad3, %MF_Enabled
   Menu Add String, hPad, "4", %IDM_Pad4, %MF_Enabled
   Menu Add String, hPad, "5", %IDM_Pad5, %MF_Enabled

   Menu New PopUp To hOpen
   Menu Add String, hOpen, "Reload", %IDM_Reload, %MF_Enabled

   Menu New PopUp To hPBWin
   Menu Add String, hPBWin, "Select IDE", %IDM_SelectIDE, %MF_Enabled
   Menu Add String, hPBWin, "Select Compiler", %IDM_SelectCompiler, %MF_Enabled
   Menu Add String, hPBWin, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hPBWin, "Select PowerBASIC Include Folder", %IDM_SelectPBInclude, %MF_Enabled
   Menu Add String, hPBWin, "Select Jose Roca Include Folder", %IDM_SelectJoseRocaInclude, %MF_Enabled
   Menu Add String, hPBWin, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hPBWin, "Use Jose Roca Includes", %IDM_UseJose, %MF_Enabled

   Menu New PopUp To hSettings
   Menu Add String, hSettings, "Manage Blank Lines", %IDM_ManageBlankLines, %MF_Enabled
   Menu Add String, hSettings, "Standardize Comments", %IDM_StdComment, %MF_Enabled
   Menu Add String, hSettings, "Remove Blanks in Plain", %IDM_RemoveBlanks, %MF_Enabled
   Menu Add String, hSettings, "Show Text in Toolbar", %IDM_ToolbarText, %MF_Enabled
   Menu Add String, hSettings, "Minimal Toolbar Buttons", %IDM_MiniBar, %MF_Enabled
   Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hSettings, "Select Font...", %IDM_Font, %MF_Enabled
   Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hSettings, "Select KeyWord Color...", %IDM_ColorKeyWord, %MF_Enabled
   Menu Add String, hSettings, "Select String Color...", %IDM_ColorString, %MF_Enabled
   Menu Add String, hSettings, "Select Comment Color...", %IDM_ColorComment, %MF_Enabled
   Menu Add String, hSettings, "Select Operator Color...", %IDM_ColorOperator, %MF_Enabled
   Menu Add String, hSettings, "Select Number Color...", %IDM_ColorNumber, %MF_Enabled
   Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
   Menu Add PopUp, hSettings, "Indent Size", hIndent, %MF_Enabled
   Menu Add PopUp, hSettings, "Max Consecutive Blank Lines", hMaxB, %MF_Enabled
   Menu Add PopUp, hSettings, "Pre-Procedure Blank Lines", hProcB, %MF_Enabled
   Menu Add PopUp, hSettings, "Comment Pad (#Spaces)", hPad, %MF_Enabled
End Sub

Sub LoadKeyWords
   Open $KeyWordFile For Binary As #1
   Get$ #1, Lof(1), KeyWords
   Close #1
   Replace $CrLf With $Spc In Keywords
   Keywords = LCase$(Keywords)
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "200", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "200", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "1030", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "500", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FileName", Exe.Path$ + "files\sample.bas", FileName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileExt", ".bas.inc.txt", FileExt, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FontName", "Courier New", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SearchTermD", "", SearchTermD, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ReplaceTermD", "", ReplaceTermD, %Max_Path, INIFileName

      Getprivateprofilestring "All", "PathIDE", "c:\pbwin10\bin\pbedit.exe", PathIDE, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PathCompiler", "c:\pbwin10\bin\pbwin.exe", PathCompiler, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PathIncludePB", "c:\pbwin10\winapi\", PathIncludePB, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PathIncludeJR", "c:\pbwin10\roca\", PathIncludeJR, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "UseJose", "1", temp, %Max_Path, INIFileName:  UseJose = Val(temp)

      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "TBH", "55", temp, %Max_Path, INIFileName:  TBH = Val(temp)
      Getprivateprofilestring "All", "SciMargin", "40", temp, %Max_Path, INIFileName:  SciMargin = Val(temp)
      Getprivateprofilestring "All", "LastGoTo", "1", temp, %Max_Path, INIFileName:  LastGoTo = Val(temp)

      Getprivateprofilestring "All", "ColorKeyWord", Str$(%Blue), temp, %Max_Path, INIFileName:  ColorKeyWord = Val(temp)
      Getprivateprofilestring "All", "ColorString", Str$(RGB(255,25,25)), temp, %Max_Path, INIFileName:  ColorString = Val(temp)
      Getprivateprofilestring "All", "ColorComment", Str$(%rgb_DarkGreen), temp, %Max_Path, INIFileName:  ColorComment = Val(temp)
      Getprivateprofilestring "All", "ColorOperator", Str$(RGB(25,25,25)), temp, %Max_Path, INIFileName:  ColorOperator = Val(temp)
      Getprivateprofilestring "All", "ColorNumber", Str$(%rgb_SaddleBrown), temp, %Max_Path, INIFileName:  ColorNumber = Val(temp)

      Getprivateprofilestring "All", "MiniBar", "0", temp, %Max_Path, INIFileName : MiniBar = Val(temp)
      Getprivateprofilestring "All", "ToolbarText", "1", temp, %Max_Path, INIFileName : ToolbarText = Val(temp)
      Getprivateprofilestring "All", "ManageBlankLines", "1", temp, %Max_Path, INIFileName : ManageBlankLines = Val(temp)
      Getprivateprofilestring "All", "StdComment", "1", temp, %Max_Path, INIFileName : StdComment = Val(temp)
      Getprivateprofilestring "All", "RemoveBlanks", "1", temp, %Max_Path, INIFileName : RemoveBlanks = Val(temp)

      Getprivateprofilestring "All", "procB", "2", temp, %Max_Path, INIFileName : procB = Val(temp)
      Getprivateprofilestring "All", "maxB", "1", temp, %Max_Path, INIFileName : maxB = Val(temp)
      Getprivateprofilestring "All", "IndentSize", "3", temp, %Max_Path, INIFileName:  IndentSize = Val(temp)
      Getprivateprofilestring "All", "CommentPad", "1", temp, %Max_Path, INIFileName:  CommentPad = Val(temp)
      For x = 0 To 15
         Getprivateprofilestring "All", "CustomColorC" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next x

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      WritePrivateProfileString "All", "FileExt",FileExt, INIFileName
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "SearchTermD",SearchTermD, INIFileName
      WritePrivateProfileString "All", "ReplaceTermD",ReplaceTermD, INIFileName

      WritePrivateProfileString "All", "PathIDE",PathIDE, INIFileName
      WritePrivateProfileString "All", "PathIncludePB",PathIncludePB, INIFileName
      WritePrivateProfileString "All", "PathIncludeJR",PathIncludeJR, INIFileName
      WritePrivateProfileString "All", "PathCompiler",PathCompiler, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "UseJose", Str$(UseJose), INIFileName

      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "TBH", (Str$(TBH)), INIFileName
      WritePrivateProfileString "All", "SciMargin", (Str$(SciMargin)), INIFileName
      WritePrivateProfileString "All", "LastGoTo", (Str$(LastGoTo)), INIFileName

      WritePrivateProfileString "All", "ColorKeyWord", (Str$(ColorKeyWord)), INIFileName
      WritePrivateProfileString "All", "ColorString", (Str$(ColorString)), INIFileName
      WritePrivateProfileString "All", "ColorComment", (Str$(ColorComment)), INIFileName
      WritePrivateProfileString "All", "ColorOperator", (Str$(ColorOperator)), INIFileName
      WritePrivateProfileString "All", "ColorComment", (Str$(ColorComment)), INIFileName

      WritePrivateProfileString "All", "MiniBar", (Str$(MiniBar)), INIFileName
      WritePrivateProfileString "All", "ToolbarText", (Str$(ToolbarText)), INIFileName
      WritePrivateProfileString "All", "ManageBlankLines", (Str$(ManageBlankLInes)), INIFileName
      WritePrivateProfileString "All", "StdComment", (Str$(StdComment)), INIFileName
      WritePrivateProfileString "All", "RemoveBlanks", (Str$(RemoveBlanks)), INIFileName

      WritePrivateProfileString "All", "procB", (Str$(procB)), INIFileName
      WritePrivateProfileString "All", "maxB", (Str$(maxB)), INIFileName
      WritePrivateProfileString "All", "IndentSize", Str$(IndentSize), INIFileName
      WritePrivateProfileString "All", "CommentPad", Str$(CommentPad), INIFileName
      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "All", "CustomColorC" + Format$(x,"00"), temp, INIFileName
      Next x
   End If
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
'    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Power, IIf(Power,%TBState_Checked,0) Or %TBState_Enabled
   'Menus
    Menu Set State hPBWin, ByCmd %IDM_UseJose, UseJose * %MFS_Checked Or %MFS_Enabled

    Menu Set State hSettings, ByCmd %IDM_MiniBar, IIf(MiniBar,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_ToolbarText, IIf(ToolbarText,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_ManageBlankLines, IIf(ManageBlankLines,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_StdComment, IIf(StdComment,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_RemoveBlanks, IIf(RemoveBlanks,%MFS_Checked,0) Or %MFS_Enabled

    Menu Set State hIndent, ByCmd %IDM_Indent0, IIf(IndentSize=0,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hIndent, ByCmd %IDM_Indent1, IIf(IndentSize=1,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hIndent, ByCmd %IDM_Indent2, IIf(IndentSize=2,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hIndent, ByCmd %IDM_Indent3, IIf(IndentSize=3,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hIndent, ByCmd %IDM_Indent4, IIf(IndentSize=4,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hIndent, ByCmd %IDM_Indent5, IIf(IndentSize=5,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hIndent, ByCmd %IDM_Indent6, IIf(IndentSize=6,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hIndent, ByCmd %IDM_Indent7, IIf(IndentSize=7,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hIndent, ByCmd %IDM_Indent8, IIf(IndentSize=8,%MFS_Checked,0) Or %MFS_Enabled

    Menu Set State hMaxB, ByCmd %IDM_MaxB0, IIf(MaxB=0,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hMaxB, ByCmd %IDM_MaxB1, IIf(MaxB=1,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hMaxB, ByCmd %IDM_MaxB2, IIf(MaxB=2,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hMaxB, ByCmd %IDM_MaxB3, IIf(MaxB=3,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hMaxB, ByCmd %IDM_MaxB4, IIf(MaxB=4,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hMaxB, ByCmd %IDM_MaxB5, IIf(MaxB=5,%MFS_Checked,0) Or %MFS_Enabled

    Menu Set State hProcB, ByCmd %IDM_ProcB0, IIf(ProcB=0,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hProcB, ByCmd %IDM_ProcB1, IIf(ProcB=1,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hProcB, ByCmd %IDM_ProcB2, IIf(ProcB=2,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hProcB, ByCmd %IDM_ProcB3, IIf(ProcB=3,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hProcB, ByCmd %IDM_ProcB4, IIf(ProcB=4,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hProcB, ByCmd %IDM_ProcB5, IIf(ProcB=5,%MFS_Checked,0) Or %MFS_Enabled

    Menu Set State hPad, ByCmd %IDM_Pad0, IIf(CommentPad=0,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hPad, ByCmd %IDM_Pad1, IIf(CommentPad=1,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hPad, ByCmd %IDM_Pad2, IIf(CommentPad=2,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hPad, ByCmd %IDM_Pad3, IIf(CommentPad=3,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hPad, ByCmd %IDM_Pad4, IIf(CommentPad=4,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hPad, ByCmd %IDM_Pad5, IIf(CommentPad=5,%MFS_Checked,0) Or %MFS_Enabled

   'statusbar
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, " ManageB: " + IIf$(ManageBlankLines,"Yes","No") _
   + "   RemoveB: " + IIf$(RemoveBlanks,"Yes","No") _
   + "   StandardC: " + IIf$(StdComment,"Yes","No") + "   Indent:" + Str$(IndentSize) _
   + "   ProcB:" + Str$(ProcB) + "   MaxB:" + Str$(MaxB) + "   PadB:" + Str$(CommentPad)
End Sub

Function SelectAndOpenFile As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "Source Code (*.bas,*.inc)" + $Nul + "*.bas;*.inc" + $Nul
    startfolder$ = IIf$(IsFile(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       FileName = filevar$
       LoadFileName
    End If
End Function

Sub LoadFileName
   Local temp$
   Open FileName For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1
   SendMessage hSci, %SCI_SetText, 0, StrPtr(temp$)            'set text
   Sci_EmptyUndoBuffer hSci
   Dialog Set Text hDlg, "gbCodeIndent  v" + $Ver + "     " + FileName
End Sub

Function SaveAsFile() As String
   Local title$, sfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
   title$ = ""                'caption title. if "", then "Save As" is displayed
   sfolder$ = PathName$(Path,FileName)
   filter$ = "Source Code Files (*.bas,*.inc)" + $Nul + "*.bas;*.inc" + $Nul
   startfile$ = FileName      'name to be used as initial selection
   defaultext$ = "bas"        'default extension to append to selection if user does not enter it
   flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
   Display Savefile hDlg, 100, 100, title$, sfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then
      FileName = filevar$
      SaveFileName
   End If
End Function

Sub SaveFileName
   Local temp$
   temp$ = Sci_GetText(hSci)
   Open FileName For Binary As #1
   Put$ #1, temp$
   SetEof #1
   Close #1
   Sci_EmptyUndoBuffer hSci
End Sub

Function SelectMainFont() As Long
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx ghHook
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      SetSciFont
   End If
End Function

Function FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal WParam, ByVal LParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
   End If
End Function

Sub SetSciFont
   Local fName As String
   fName = FontName + $Nul
   SendMessage hSci, %Sci_StyleSetFont, %Style_Default, StrPtr(fName)  'default style to Courier new
   SendMessage hSci, %SCI_StyleSetSize, %Style_Default, FontSize&      'default style size to 10 points
   SendMessage hSci, %SCI_StyleSetBold, %Style_Default, FontAttr       'default style is BOLD
End Sub

Sub ShowReport
   Local temp$
   temp$ += "Manage blank lines: " + IIf$(ManageBlankLines,"Yes","No") + $CrLf
   temp$ += "Standard Comments:" + IIf$(StdComment,"Yes","No") + $CrLf
   temp$ += "Remove Plain Blanks: " + IIf$(RemoveBlanks,"Yes","No") + $CrLf + $CrLf
   temp$ += "Comment pad:" + Str$(CommentPad) + $CrLf
   temp$ += "Identation size:" + Str$(IndentSize) + $CrLf
   temp$ += "Max consecutive blank lines:" + Str$(MaxB) + $CrLf
   temp$ += "Blank lines preceding procedures:" + Str$(ProcB)
   MsgBox temp$, %MB_Ok + %MB_TaskModal + %MB_IconInformation,"Settings"
End Sub

Function SelectColor(FirstColor As Long) As Long
   Local ColorResult&, Flags&
   Flags& = %CC_FullOpen      'PreventFullOpen
   Display Color hDlg, 100, 100, FirstColor, CustomColorList ,Flags& To ColorResult&
   If ColorResult& = -1 Then
      Function = FirstColor
   Else
      Function = ColorResult&
   End If
End Function

Sub GotoLine
   Local w,h,iResult As Long, temp$
   Dialog Get Loc hDlg To w,h
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Go To Line", Str$(LastGoTo), w+40,h+150)
   UnhookWindowsHookEx ghHook
   If Len(temp$) = 0 Then Exit Sub  'ESC was presed
   If (Val(temp$) < 1) Then Beep: Exit Sub
   LastGoTo = Val(temp$)
   Sci_GoToLine hSci, LastGoTo-1
   Sci_SetFirstVisibleLine hSci, LastGoTo-1
End Sub

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 120  : @cst.cx = 60           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 100 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub OpenInIDE
   Local iReturn As Long, temp$
   If IsFalse(IsFile(PathIDE)) Then Beep : Exit Sub
   temp$ = Sci_GetText(hSci)
   Open $TempSourceCodeFile_IDE For Output As #1
   Print #1, temp$
   Close #1
   iReturn = Shell(PathIDE + " " + $TempSourceCodeFile_IDE, 1)  : Exit Sub   'does not wait
End Sub

Sub SelectIDE
   Local title$, sfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
   title$ = "Select IDE"    'caption title. if "", then "Open" is displayed
   filter$ = "IDE" + $Nul + "*.exe" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
   sfolder$ = PathIDE    'initial folder to be displayed
   startfile$ = IIf$(IsFile(PathIDE), PathIDE, "")
   defaultext$ = "exe"                 'default extension to append to selection if user does not enter it
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, title$, sfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then PathIDE = filevar$
End Sub

Sub SelectCompiler
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = "Select Compiler"    'caption title. if "", then "Open" is displayed
    filter$ = "Compiler" + $Nul + "*.exe" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfolder$ = PathCompiler    'initial folder to be displayed
    startfile$ = IIf$(IsFile(PathCompiler), PathCompiler, "")
    defaultext$ = "exe"                 'default extension to append to selection if user does not enter it
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then PathCompiler = filevar$
End Sub

Sub SelectJoseRocaInclude
   Local title$, start$, flags&, folder$
   title$ = "Select Path to Include Files"    'if "" then "Open" is used
   start$ = PathIncludeJR
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$
   'folder$ is set to "" if Cancel/Escape is pressed
   If Len(folder$) Then PathIncludeJR = folder$
End Sub

Sub SelectPBInclude
   Local title$, start$, flags&, folder$
   title$ = "Select Path to Include Files"    'if "" then "Open" is used
   start$ = PathIncludePB
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$
   'folder$ is set to "" if Cancel/Escape is pressed
   If Len(folder$) Then PathIncludePB = folder$
End Sub

Sub CreateSubFolders
   If IsFolder (Exe.Path$ + "tempfiles") = %False Then MkDir Exe.Path$ + "tempfiles"
End Sub

Sub CompileAndRun
   Local iReturn, hProcess, hWnd As Dword, CmdString, temp As String
   On Error GoTo CompileError

   If IsFalse(IsFile(PathCompiler)) Then
       MsgBox "PowerBASIC compiler not found!", %MB_Ok + %MB_TaskModal + %MB_IconExclamation, "Compile & Execute"
       Exit Sub
   End If

   temp$ = Sci_GetText(hSci)

   Open $TempSourceCodeFile_Compiler For Output As #1
   Print #1, temp$
   Close #1

   'compile
   ChDir Exe.Path$ + "tempfiles"
   If IsFile(Exe.Path$ + $LogFile) Then Kill Exe.Path$ + $LogFile
   CmdString = PathCompiler + " /I" + $Dq + IIf$(UseJose,PathIncludeJR,PathIncludePB) + $Dq + " " + $Dq + Exe.Path$ + $TempSourceCodeFile_Compiler + $Dq + "/L /Q"

   Shell CmdString, 1     'make EXE, wait for compiler to complete

   'check log file for error
   iReturn = 0
   If IsFile(Exe.Path$ + $LogFile) Then
      Open Exe.Path$ + $LogFile For Binary As #1
      Get$ #1, Lof(1), temp$    'filedata$ will contain $crlf's from the file
      Close #1                      'LOF() returns number of bytes in an Open file
      If InStr(LCase$(temp$),"error ") Then  'ask user if wants to open log file
         iReturn = 1
         If MsgBox ("Error during compilation. Open compile log?", %MB_OkCancel + %MB_TaskModal +  %MB_IconInformation, "Compile and Execute") = %IdOk Then
            iReturn = Shell("notepad.exe " + Exe.Path$ + $LogFile, 1)   'does not wait
         End If
      End If
   End If

   If iReturn = 0 Then
      'no error, run the resulting EXE
      If IsFile(Exe.Path$ + $ExeFile) Then
         iReturn = Shell($EXEFile)       'run EXE
      Else
         MsgBox "Cannot locate EXE file!", %MB_Ok + %MB_TaskModal + %MB_TaskModal +  %MB_IconInformation, "Compile and Execute"
      End If
   End If

   ChDir Exe.Path$

   Exit Sub

CompileError:
   MsgBox "Error " + Str$(Err) + " " + Error$(Err)
End Sub
